### Constructor

# FwupdPlugin ChunkArray new_virtual

#### Declaration [src]

    FuChunkArray*
    fu_chunk_array_new_virtual (
      gsize bufsz,
      gsize addr_offset,
      gsize page_sz,
      gsize packet_sz
    )

#### Description [src]

Chunks a virtual buffer memory into packets, ensuring each packet is less that a specific transfer size.

Available since: | 2.0.2

#### Parameters

`bufsz` | `gsize`
| Size of the buffer.
`addr_offset` | `gsize`
| The hardware address offset, or `FU_CHUNK_ADDR_OFFSET_NONE`.
`page_sz` | `gsize`
| The hardware page size, typically `FU_CHUNK_PAGESZ_NONE`.
`packet_sz` | `gsize`
| The packet size, or 0x0

#### Return value

Returns: | `FuChunkArray`
| A `FuChunkArray`.
| The caller of the function takes ownership of the data, and is responsible for freeing it.